3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] [--] <path>...
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--reference <repository>] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
22 wt_prefix=$(git rev-parse --show-prefix)
25 # Restrict ourselves to a vanilla subset of protocols; the URLs
26 # we get are under control of a remote repository, and we do not
27 # want them kicking off arbitrary git-remote-* programs.
29 # If the user has already specified a set of allowed protocols,
30 # we assume they know what they're doing and use that instead.
31 : ${GIT_ALLOW_PROTOCOL=file:git:http:https:ssh}
32 export GIT_ALLOW_PROTOCOL
49 # The function takes at most 2 arguments. The first argument is the
50 # URL that navigates to the submodule origin repo. When relative, this URL
51 # is relative to the superproject origin URL repo. The second up_path
52 # argument, if specified, is the relative path that navigates
53 # from the submodule working tree to the superproject working tree.
55 # The output of the function is the origin URL of the submodule.
57 # The output will either be an absolute URL or filesystem path (if the
58 # superproject origin URL is an absolute URL or filesystem path,
59 # respectively) or a relative file system path (if the superproject
60 # origin URL is a relative file system path).
62 # When the output is a relative file system path, the path is either
63 # relative to the submodule working tree, if up_path is specified, or to
64 # the superproject working tree otherwise.
65 resolve_relative_url ()
67 remote=$(get_default_remote)
68 remoteurl=$(git config "remote.$remote.url") ||
69 remoteurl=$(pwd) # the repository is its own authoritative upstream
71 remoteurl=${remoteurl%/}
84 remoteurl="./$remoteurl"
95 remoteurl="${remoteurl%/*}"
98 remoteurl="${remoteurl%:*}"
102 if test -z "$is_relative" || test "." = "$remoteurl"
104 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
118 remoteurl="$remoteurl$sep${url%/}"
119 echo "${is_relative:+${up_path}}${remoteurl#./}"
122 # Resolve a path to be relative to another path. This is intended for
123 # converting submodule paths when git-submodule is run in a subdirectory
124 # and only handles paths where the directory separator is '/'.
126 # The output is the first argument as a path relative to the second argument,
127 # which defaults to $wt_prefix if it is omitted.
130 local target curdir result
132 curdir=${2-$wt_prefix}
136 while test -n "$curdir"
140 target=${target#"$curdir"/}
145 result="${result}../"
146 if test "$curdir" = "${curdir%/*}"
150 curdir="${curdir%/*}"
154 echo "$result$target"
158 # Get submodule info for registered submodules
159 # $@ = path to limit submodule list
163 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
165 git ls-files -z --error-unmatch --stage -- "$@" ||
166 echo "unmatched pathspec exists"
170 my ($null_sha1) = ("0" x 40);
175 if (/^unmatched pathspec/) {
180 my ($mode, $sha1, $stage, $path) =
181 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
182 next unless $mode eq "160000";
184 if (!$unmerged{$path}++) {
185 push @out, "$mode $null_sha1 U\t$path\n";
192 print "#unmatched\n";
201 if test "$1" = "#unmatched"
208 # Print a submodule configuration setting
210 # $1 = submodule name
214 # Checks in the usual git-config places first (for overrides),
215 # otherwise it falls back on .gitmodules. This allows you to
216 # distribute project-wide defaults in .gitmodules, while still
217 # customizing individual repositories if necessary. If the option is
218 # not in .gitmodules either, print a default value.
220 get_submodule_config () {
224 value=$(git config submodule."$name"."$option")
227 value=$(git config -f .gitmodules submodule."$name"."$option")
229 printf '%s' "${value:-$default}"
234 # Map submodule path to submodule name
240 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
242 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
243 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
244 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
246 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$sm_path'")"
247 printf '%s\n' "$name"
253 # $1 = submodule path
254 # $2 = submodule name
256 # $4 = reference repository to reuse (empty for independent)
257 # $5 = depth argument for shallow clones (empty for deep)
259 # Prior to calling, cmd_update checks that a possibly existing
260 # path is not a git repository.
261 # Likewise, cmd_add checks that path does not exist at all,
262 # since it is the location of a new submodule.
272 if test -n "$GIT_QUIET"
279 base_name=$(dirname "$name")
281 gitdir=$(git rev-parse --git-dir)
282 gitdir_base="$gitdir/modules/$base_name"
283 gitdir="$gitdir/modules/$name"
288 rm -f "$gitdir/index"
290 mkdir -p "$gitdir_base"
293 git clone $quiet ${depth:+"$depth"} -n ${reference:+"$reference"} \
294 --separate-git-dir "$gitdir" "$url" "$sm_path"
296 die "$(eval_gettext "Clone of '\$url' into submodule path '\$sm_path' failed")"
299 # We already are at the root of the work tree but cd_to_toplevel will
300 # resolve any symlinks that might be present in $PWD
301 a=$(cd_to_toplevel && cd "$gitdir" && pwd)/
302 b=$(cd_to_toplevel && cd "$sm_path" && pwd)/
303 # Remove all common leading directories after a sanity check
304 if test "${a#$b}" != "$a" || test "${b#$a}" != "$b"; then
305 die "$(eval_gettext "Gitdir '\$a' is part of the submodule path '\$b' or vice versa")"
307 while test "${a%%/*}" = "${b%%/*}"
312 # Now chop off the trailing '/'s that were added in the beginning
316 # Turn each leading "*/" component into "../"
317 rel=$(printf '%s\n' "$b" | sed -e 's|[^/][^/]*|..|g')
318 printf '%s\n' "gitdir: $rel/$a" >"$sm_path/.git"
320 rel=$(printf '%s\n' "$a" | sed -e 's|[^/][^/]*|..|g')
321 (clear_local_git_env; cd "$sm_path" && GIT_WORK_TREE=. git config core.worktree "$rel/$b")
326 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
330 # Add a new submodule to the working tree, .gitmodules and the index
334 # optional branch is stored in global branch variable
338 # parse $args after "submodule ... add".
344 case "$2" in '') usage ;; esac
355 case "$2" in '') usage ;; esac
360 reference_path="${1#--reference=}"
363 case "$2" in '') usage ;; esac
368 case "$2" in '') usage ;; esac
389 if test -n "$reference_path"
391 is_absolute_path "$reference_path" ||
392 reference_path="$wt_prefix$reference_path"
394 reference="--reference=$reference_path"
400 if test -z "$sm_path"; then
401 sm_path=$(printf '%s\n' "$repo" |
402 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
405 if test -z "$repo" || test -z "$sm_path"; then
409 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
411 # assure repo is absolute or relative to parent
414 test -z "$wt_prefix" ||
415 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
417 # dereference source url relative to parent's url
418 realrepo=$(resolve_relative_url "$repo") || exit
425 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
430 # multiple //; leading ./; /./; /../; trailing /
431 sm_path=$(printf '%s/\n' "$sm_path" |
441 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
442 die "$(eval_gettext "'\$sm_path' already exists in the index")"
444 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
446 eval_gettextln "The following path is ignored by one of your .gitignore files:
448 Use -f if you really want to add it." >&2
452 if test -n "$custom_name"
454 sm_name="$custom_name"
459 # perhaps the path exists and is already a git repo, else clone it
460 if test -e "$sm_path"
462 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
464 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
466 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
470 if test -d ".git/modules/$sm_name"
474 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
475 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
476 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
477 echo >&2 " $realrepo"
478 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
479 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
481 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
484 module_clone "$sm_path" "$sm_name" "$realrepo" "$reference" "$depth" || exit
488 # ash fails to wordsplit ${branch:+-b "$branch"...}
490 '') git checkout -f -q ;;
491 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
493 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
495 git config submodule."$sm_name".url "$realrepo"
497 git add $force "$sm_path" ||
498 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
500 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
501 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
504 git config -f .gitmodules submodule."$sm_name".branch "$branch"
506 git add --force .gitmodules ||
507 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
511 # Execute an arbitrary command sequence in each checked out
514 # $@ = command to execute
518 # parse $args after "submodule ... foreach".
540 # dup stdin so that it can be restored when running the external
541 # command in the subshell (and a recursive call to this function)
545 while read mode sha1 stage sm_path
547 die_if_unmatched "$mode"
548 if test -e "$sm_path"/.git
550 displaypath=$(relative_path "$sm_path")
551 say "$(eval_gettext "Entering '\$prefix\$displaypath'")"
552 name=$(module_name "$sm_path")
554 prefix="$prefix$sm_path/"
557 sm_path=$(relative_path "$sm_path") &&
558 # we make $path available to scripts ...
566 if test -n "$recursive"
568 cmd_foreach "--recursive" "$@"
571 die "$(eval_gettext "Stopping at '\$prefix\$displaypath'; script returned non-zero status.")"
577 # Register submodules in .git/config
579 # $@ = requested paths (default to all)
583 # parse $args after "submodule ... init".
605 while read mode sha1 stage sm_path
607 die_if_unmatched "$mode"
608 name=$(module_name "$sm_path") || exit
610 displaypath=$(relative_path "$sm_path")
612 # Copy url setting when it is not set yet
613 if test -z "$(git config "submodule.$name.url")"
615 url=$(git config -f .gitmodules submodule."$name".url)
617 die "$(eval_gettext "No url found for submodule path '\$displaypath' in .gitmodules")"
619 # Possibly a url relative to parent
622 url=$(resolve_relative_url "$url") || exit
625 git config submodule."$name".url "$url" ||
626 die "$(eval_gettext "Failed to register url for submodule path '\$displaypath'")"
628 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$displaypath'")"
631 # Copy "update" setting when it is not set yet
632 if upd="$(git config -f .gitmodules submodule."$name".update)" &&
634 test -z "$(git config submodule."$name".update)"
637 checkout | rebase | merge | none)
638 ;; # known modes of updating
640 echo >&2 "warning: unknown update mode '$upd' suggested for submodule '$name'"
644 git config submodule."$name".update "$upd" ||
645 die "$(eval_gettext "Failed to register update mode for submodule path '\$displaypath'")"
651 # Unregister submodules from .git/config and remove their work tree
653 # $@ = requested paths (use '.' to deinit all submodules)
657 # parse $args after "submodule ... deinit".
683 die "$(eval_gettext "Use '.' if you really want to deinitialize all submodules")"
687 while read mode sha1 stage sm_path
689 die_if_unmatched "$mode"
690 name=$(module_name "$sm_path") || exit
692 displaypath=$(relative_path "$sm_path")
694 # Remove the submodule work tree (unless the user already did it)
695 if test -d "$sm_path"
697 # Protect submodules containing a .git directory
698 if test -d "$sm_path/.git"
700 echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
701 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
706 git rm -qn "$sm_path" ||
707 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
710 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
711 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
714 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
716 # Remove the .git/config entries (unless the user already did it)
717 if test -n "$(git config --get-regexp submodule."$name\.")"
719 # Remove the whole section so we have a clean state when
720 # the user later decides to init this submodule again
721 url=$(git config submodule."$name".url)
722 git config --remove-section submodule."$name" 2>/dev/null &&
723 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
729 # Update each submodule path to correct revision, using clone and checkout as needed
731 # $@ = requested paths (default to all)
735 # parse $args after "submodule ... update".
758 case "$2" in '') usage ;; esac
759 reference="--reference=$2"
775 case "$2" in '') usage ;; esac
798 cmd_init "--" "$@" || return
804 while read mode sha1 stage sm_path
806 die_if_unmatched "$mode"
809 echo >&2 "Skipping unmerged submodule $prefix$sm_path"
812 name=$(module_name "$sm_path") || exit
813 url=$(git config submodule."$name".url)
814 branch=$(get_submodule_config "$name" branch master)
815 if ! test -z "$update"
817 update_module=$update
819 update_module=$(git config submodule."$name".update)
820 if test -z "$update_module"
822 update_module="checkout"
826 displaypath=$(relative_path "$prefix$sm_path")
828 if test "$update_module" = "none"
830 echo "Skipping submodule '$displaypath'"
836 # Only mention uninitialized submodules when its
837 # path have been specified
839 say "$(eval_gettext "Submodule path '\$displaypath' not initialized
840 Maybe you want to use 'update --init'?")"
844 if ! test -d "$sm_path"/.git && ! test -f "$sm_path"/.git
846 module_clone "$sm_path" "$name" "$url" "$reference" "$depth" || exit
847 cloned_modules="$cloned_modules;$name"
850 subsha1=$(clear_local_git_env; cd "$sm_path" &&
851 git rev-parse --verify HEAD) ||
852 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
857 if test -z "$nofetch"
859 # Fetch remote before determining tracking $sha1
860 (clear_local_git_env; cd "$sm_path" && git-fetch) ||
861 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
863 remote_name=$(clear_local_git_env; cd "$sm_path" && get_default_remote)
864 sha1=$(clear_local_git_env; cd "$sm_path" &&
865 git rev-parse --verify "${remote_name}/${branch}") ||
866 die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
869 if test "$subsha1" != "$sha1" || test -n "$force"
872 # If we don't already have a -f flag and the submodule has never been checked out
873 if test -z "$subsha1" && test -z "$force"
878 if test -z "$nofetch"
880 # Run fetch only if $sha1 isn't present or it
881 # is not reachable from a ref.
882 (clear_local_git_env; cd "$sm_path" &&
883 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
884 test -z "$rev") || git-fetch)) ||
885 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
888 # Is this something we just cloned?
889 case ";$cloned_modules;" in
891 # then there is no local change to integrate
892 update_module=checkout ;;
896 case "$update_module" in
898 command="git checkout $subforce -q"
899 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
900 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
904 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
905 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
906 must_die_on_failure=yes
910 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
911 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
912 must_die_on_failure=yes
915 command="${update_module#!}"
916 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$prefix\$sm_path'")"
917 say_msg="$(eval_gettext "Submodule path '\$prefix\$sm_path': '\$command \$sha1'")"
918 must_die_on_failure=yes
921 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
924 if (clear_local_git_env; cd "$sm_path" && $command "$sha1")
927 elif test -n "$must_die_on_failure"
929 die_with_status 2 "$die_msg"
931 err="${err};$die_msg"
936 if test -n "$recursive"
939 prefix="$prefix$sm_path/"
947 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
950 err="${err};$die_msg"
953 die_with_status $res "$die_msg"
980 git describe "$2" 2>/dev/null ||
981 git describe --tags "$2" 2>/dev/null ||
982 git describe --contains "$2" 2>/dev/null ||
983 git describe --all --always "$2"
986 test -z "$revname" || revname=" ($revname)"
989 # Show commit summary for submodules in index or working tree
991 # If '--cached' is given, show summary between index and given commit,
992 # or between working tree and given commit
994 # $@ = [commit (default 'HEAD'),] requested paths (default all)
1001 # parse $args after "submodule ... summary".
1016 isnumber "$summary_limit" || usage
1020 summary_limit="${1#--summary-limit=}"
1021 isnumber "$summary_limit" || usage
1037 test $summary_limit = 0 && return
1039 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
1042 test $# = 0 || shift
1043 elif test -z "$1" || test "$1" = "HEAD"
1045 # before the first commit: compare with an empty tree
1046 head=$(git hash-object -w -t tree --stdin </dev/null)
1047 test -z "$1" || shift
1054 test -n "$cached" &&
1055 die "$(gettext "The --cached option cannot be used with the --files option")"
1061 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
1062 # Get modified modules cared by user
1063 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
1064 sane_egrep '^:([0-7]* )?160000' |
1065 while read mod_src mod_dst sha1_src sha1_dst status sm_path
1067 # Always show modules deleted or type-changed (blob<->module)
1068 if test "$status" = D || test "$status" = T
1070 printf '%s\n' "$sm_path"
1073 # Respect the ignore setting for --for-status.
1074 if test -n "$for_status"
1076 name=$(module_name "$sm_path")
1077 ignore_config=$(get_submodule_config "$name" ignore none)
1078 test $status != A && test $ignore_config = all && continue
1080 # Also show added or modified modules which are checked out
1081 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
1082 printf '%s\n' "$sm_path"
1086 test -z "$modules" && return
1088 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
1089 sane_egrep '^:([0-7]* )?160000' |
1091 while read mod_src mod_dst sha1_src sha1_dst status name
1093 if test -z "$cached" &&
1094 test $sha1_dst = 0000000000000000000000000000000000000000
1098 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
1100 100644 | 100755 | 120000)
1101 sha1_dst=$(git hash-object $name)
1107 eval_gettextln "unexpected mode \$mod_dst" >&2
1114 test $mod_src = 160000 &&
1115 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1118 test $mod_dst = 160000 &&
1119 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1122 display_name=$(relative_path "$name")
1125 case "$missing_src,$missing_dst" in
1127 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1130 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1133 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1138 if test $mod_src = 160000 && test $mod_dst = 160000
1140 range="$sha1_src...$sha1_dst"
1141 elif test $mod_src = 160000
1147 GIT_DIR="$name/.git" \
1148 git rev-list --first-parent $range -- | wc -l
1150 total_commits=" ($(($total_commits + 0)))"
1154 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
1155 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
1158 blob="$(gettext "blob")"
1159 submodule="$(gettext "submodule")"
1160 if test $mod_dst = 160000
1162 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1164 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1167 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1169 if test -n "$errmsg"
1171 # Don't give error msg for modification whose dst is not submodule
1172 # i.e. deleted or changed to blob
1173 test $mod_dst = 160000 && echo "$errmsg"
1175 if test $mod_src = 160000 && test $mod_dst = 160000
1178 test $summary_limit -gt 0 && limit="-$summary_limit"
1179 GIT_DIR="$name/.git" \
1180 git log $limit --pretty='format: %m %s' \
1181 --first-parent $sha1_src...$sha1_dst
1182 elif test $mod_dst = 160000
1184 GIT_DIR="$name/.git" \
1185 git log --pretty='format: > %s' -1 $sha1_dst
1187 GIT_DIR="$name/.git" \
1188 git log --pretty='format: < %s' -1 $sha1_src
1196 # List all submodules, prefixed with:
1197 # - submodule not initialized
1198 # + different revision checked out
1200 # If --cached was specified the revision in the index will be printed
1201 # instead of the currently checked out revision.
1203 # $@ = requested paths (default to all)
1207 # parse $args after "submodule ... status".
1235 while read mode sha1 stage sm_path
1237 die_if_unmatched "$mode"
1238 name=$(module_name "$sm_path") || exit
1239 url=$(git config submodule."$name".url)
1240 displaypath=$(relative_path "$prefix$sm_path")
1241 if test "$stage" = U
1243 say "U$sha1 $displaypath"
1246 if test -z "$url" ||
1248 ! test -d "$sm_path"/.git &&
1249 ! test -f "$sm_path"/.git
1252 say "-$sha1 $displaypath"
1255 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1257 set_name_rev "$sm_path" "$sha1"
1258 say " $sha1 $displaypath$revname"
1260 if test -z "$cached"
1262 sha1=$(clear_local_git_env; cd "$sm_path" && git rev-parse --verify HEAD)
1264 set_name_rev "$sm_path" "$sha1"
1265 say "+$sha1 $displaypath$revname"
1268 if test -n "$recursive"
1271 prefix="$displaypath/"
1276 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1281 # Sync remote urls for submodules
1282 # This makes the value for remote.$remote.url match the value
1283 # specified in .gitmodules.
1312 while read mode sha1 stage sm_path
1314 die_if_unmatched "$mode"
1315 name=$(module_name "$sm_path")
1316 url=$(git config -f .gitmodules --get submodule."$name".url)
1318 # Possibly a url relative to parent
1321 # rewrite foo/bar as ../.. to find path from
1322 # submodule work tree to superproject work tree
1323 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1324 # guarantee a trailing /
1325 up_path=${up_path%/}/ &&
1326 # path from submodule work tree to submodule origin repo
1327 sub_origin_url=$(resolve_relative_url "$url" "$up_path") &&
1328 # path from superproject work tree to submodule origin repo
1329 super_config_url=$(resolve_relative_url "$url") || exit
1332 sub_origin_url="$url"
1333 super_config_url="$url"
1337 if git config "submodule.$name.url" >/dev/null 2>/dev/null
1339 displaypath=$(relative_path "$prefix$sm_path")
1340 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1341 git config submodule."$name".url "$super_config_url"
1343 if test -e "$sm_path"/.git
1348 remote=$(get_default_remote)
1349 git config remote."$remote".url "$sub_origin_url"
1351 if test -n "$recursive"
1353 prefix="$prefix$sm_path/"
1362 # This loop parses the command line arguments to find the
1363 # subcommand name to dispatch. Parsing of the subcommand specific
1364 # options are primarily done by the subcommand implementations.
1365 # Subcommand specific options such as --branch and --cached are
1366 # parsed here as well, for backward compatibility.
1368 while test $# != 0 && test -z "$command"
1371 add | foreach | init | deinit | update | status | summary | sync)
1401 # No command word defaults to "status"
1402 if test -z "$command"
1412 # "-b branch" is accepted only by "add"
1413 if test -n "$branch" && test "$command" != add
1418 # "--cached" is accepted only by "status" and "summary"
1419 if test -n "$cached" && test "$command" != status && test "$command" != summary